#include <stdio.h>

#include "consumer2.h"

void consumer_init(DOLCProcess *p) {
    sprintf(p->local->name, "[consumer2]");
    p->local->index = 0;
    p->local->len = LENGTH;
}

int consumer_fire(DOLCProcess *p, int mode) {

    int valid;
    DOLCDataVar( float, inputVar);    
    dolcdata_inputVar = -1;
    
    if (p->local->index < p->local->len-1) {
        DOLC_read((void*)PORT_IN, &inputVar, 1, p);
        if (inputVar.valid) {
            printf("%s: reads %f\n", p->local->name, dolcdata_inputVar);
            p->local->index= dolcdata_inputVar;
        }
        else {
            printf("%s: no data \n", p->local->name);
        }

        //p->local->index++;
    }

    if (p->local->index >= p->local->len) {
        return 1; // terminate
    }

    return 0;
}

