#include <stdio.h>
#include <string.h>

#include "periodic3.h"

// initialization function
void periodic3_init(DOLCProcess *p) {
	p->local->index = 0;
}

// fire function
void periodic3_fire(DOLCProcess *p, int mode) {
    int r;
	DOLCDataVar(int, writeData);
   char buf[1001];
   const int sz = 1000;

	switch (mode) {
	case MODE_NORMAL: 
		PHASE("mode_normal");
	
		// Write p->local->index to data channel
		writeData.valid = true;
		*((int *)writeData.ptr) = p->local->index;
		r = DOLC_write((void*) PORT_OUT, &(writeData), 1, p);

		if (!r) {
			printf("Periodic 3(%s): Activated with index %d, sent data %d\n", thread_info(buf,sz),p->local->index, *((int *)writeData.ptr));
			fflush(stdout);
		} else {
			printf("Periodic 3(%s): Activated with index %d, write not successful\n", thread_info(buf,sz),p->local->index);
			fflush(stdout);
		}

		break;
	

	default:
		break;
	}

	p->local->index++;

	return;
}

// terminate function
void periodic3_terminate(DOLCProcess *p) {
	fflush(stdout);
}
