#include <string.h>

#include "task2.h"

// initialization function
void task2_init(DOLCProcess *p) {
	p->local->index = 0;
}

// fire function
void task2_fire(DOLCProcess *p, int modeProd) {
   char buf[1001];
   const int sz = 1000;

   switch (modeProd) {
	case MODE_NORMAL: 
		PHASE("mode_normal");
	
	    printf("Task 2 (%s): MODE_NORMAL fire with index %d, executing for 0.5 seconds.\n", thread_info(buf,sz),
                p->local->index);
	    fflush(stdout);
        execute_loop_for_msec( 500); 
        break;

	case MODE_DEGRADED:
		PHASE("mode_degraded");
	    printf("Task 2 (%s): MODE_DEGRADED fire with index %d\n", thread_info(buf,sz),
                p->local->index);
	    fflush(stdout);
		break;
	}

	p->local->index++;
	printf("===================================================\n\n");
	fflush(stdout);

	return;
}

// terminate function
void task2_terminate(DOLCProcess *p) {
	fflush(stdout);
}
