#include <string.h>

#include "task3.h"

// initialization function
void task3_init(DOLCProcess *p) {
	p->local->index = 0;
}

// fire function
void task3_fire(DOLCProcess *p, int modeProd) {
   char buf[1001];
   const int sz = 1000;
	
   switch (modeProd) {
	case MODE_NORMAL: 
		PHASE("mode_normal");
	
	    printf("Task 3 (%s): runs as well (1.6 s)\n", thread_info(buf,sz));
	    fflush(stdout);
        execute_loop_for_msec( 1600); 
       break;

	case MODE_DEGRADED:
		PHASE("mode_degraded");
	    printf("Task 3 (%s): ERROR! unexpected degraded mode?\n", thread_info(buf,sz));
	    fflush(stdout);
		break;
	}

	p->local->index++;

	return;
}

// terminate function
void task3_terminate(DOLCProcess *p) {
	fflush(stdout);
}
