#include <string.h>

#include "task1.h"

// initialization function
void task1_init(DOLCProcess *p) {
	p->local->index = 0;
}

// fire function
void task1_fire(DOLCProcess *p, int modeProd) {
    DOLCDataVar(int, writeData);
    int r;
	switch (modeProd) {
	case MODE_NORMAL: 
		PHASE("mode_normal");
	
	    printf("Task 1: MODE_NORMAL fire with index %d\n", p->local->index);

		writeData.valid = true;
		dolcdata_writeData = 11000 + p->local->index;

		r = DOLC_write((void*) PORT_P11_OUT, &(writeData), 1, p);
		if (!r) {
			printf("Task 1: Activated with index %d, send data at P11: %d\n", p->local->index, dolcdata_writeData);
			fflush(stdout);
		} else {
			printf("Task 1: Activated with index %d, send data at P11 FAILED!", p->local->index);
			fflush(stdout);
		}

		writeData.valid = true;
		dolcdata_writeData = 12000 + p->local->index;

		r = DOLC_write((void*) PORT_P12_OUT, &(writeData), 1, p);
		if (!r) {
			printf("Task 1: Activated with index %d, send data at P12: %d\n", p->local->index, dolcdata_writeData);
			fflush(stdout);
		} else {
			printf("Task 1: Activated with index %d, send data at P12 FAILED!", p->local->index);
			fflush(stdout);
		}

       break;

	case MODE_DEGRADED:
	    printf("Task 1: MODE_DEGRADED fire with index %d\n", p->local->index);
		break;
	}

	p->local->index++;

	return;
}

// terminate function
void task1_terminate(DOLCProcess *p) {
	fflush(stdout);
}
