#include <string.h>

#include "task3.h"

// initialization function
void task3_init(DOLCProcess *p) {
	p->local->index = 0;
}

// fire function
void task3_fire(DOLCProcess *p, int modeProd) {
    DOLCDataVar(int, readData);
    int r;
	switch (modeProd) {
	case MODE_NORMAL: 
		PHASE("mode_normal");
	
	    printf("Task 3: MODE_NORMAL fire with index %d\n", p->local->index);

		// Read data from data channel
		DOLC_read((void*) PORT_P31_IN, &(readData), 1, p);

		if (readData.valid) {
			printf("Task 3: Activated with index %d, read data at P31: %d\n", p->local->index, dolcdata_readData);
			fflush(stdout);
		} else {
			printf("Task 3: Activated with index %d, read EMPTY data at P31!!!\n", p->local->index);
			fflush(stdout);
		}

       break;

	case MODE_DEGRADED:
	    printf("Task 3: MODE_DEGRADED fire with index %d\n", p->local->index);
		break;
	}

	p->local->index++;

	return;
}

// terminate function
void task3_terminate(DOLCProcess *p) {
	fflush(stdout);
}
