/*
 *
 * Data structure for the petri-net 'places'
 *
 */

#ifndef PLACES_H
#define PLACES_H

class Place {
  protected:
    int nToken;
  public:
    Place() { nToken = 0; }
    Place(int n) { nToken = n; }
    ~Place() {}
    bool token() { return (nToken != 0); }
    void getToken() { nToken--; }
    void putToken() { nToken++; }
};

#endif
