#ifndef APERIODIC2_H
#define APERIODIC2_H

#include <dolc.h>

#define PORT_OUT "p220"

#define DOLC_EVENT_FINISH 1

#define MODE_NORMAL 1
#define MODE_DEGRADED 0

typedef struct _dolc_local_states{

	int index;
} Aperiodic2_State;

void aperiodic2_init(DOLCProcess *);
void aperiodic2_fire(DOLCProcess *, int);
void aperiodic2_terminate(DOLCProcess *);

#endif