#include <assert.h>

#include "aperprod_proto.h"

void Caperprod_init(void* state) {        
    Caperprod_State* my_state = (Caperprod_State*) state;
    my_state->count = 0;
    //printf("DEBUG PRO: %ux\n", (unsigned) my_state); 
}


int Caperprod_prefire(void* state, int interval, int m_max, int prefire_period) {

    int ready = 0;

    Caperprod_State* my_state = (Caperprod_State*) state;

    int kT = interval/prefire_period;
    assert( (interval % prefire_period) == 0);
    if (my_state->count ==1) {
        ready = 1;
    }
    if (my_state->count ==2) {
        ready = 1;
    }

    my_state->count++;
    //    printf("Test! %d\n", ready);
    if (my_state->count==kT) {
       my_state->count=0;
    }

    return ready;
}

