#ifndef PERIODIC1_H
#define PERIODIC1_H

#include <dolc.h>
#include "global.h"

#define PORT_OUT "p100"

#define MODE_NORMAL 1
#define MODE_DEGRADED 0

typedef struct _dolc_local_states{
	int index;
} Periodic1_State;

void periodic1_init(DOLCProcess *);
void periodic1_fire(DOLCProcess *, int);
void periodic1_terminate(DOLCProcess *);

#endif
