#ifndef PERIODIC4_H
#define PERIODIC4_H

#include <dolc.h>
#include "global.h"

#define PORT_OUT "p400"

#define MODE_NORMAL 1
#define MODE_DEGRADED 0

typedef struct _dolc_local_states {
    int index;
} Periodic4_State;

void periodic4_init(DOLCProcess *);
void periodic4_fire(DOLCProcess *, int);
void periodic4_terminate(DOLCProcess *);

#endif
